Subject: bug#35727: Connecting Geiser to Guile listening to a socket: No prompt found! (.guile to blame)

From: sirgazil <[email-masked]>
Date: Tue, 14 May 2019 06:17:19 -0500

Hi,

I'm getting a "No prompt found!" error when I try to connect Geiser to a Guile REPL like this:

1. In a terminal, run "$ guile --listen=/tmp/guile-socket"
2. In Emacs, "M-x geiser-connect-local", then "guile", and finally "/tmp/guile-socket"

When the Guile REPL start in Emacs, I get a "No prompt found!" in the echo area, and the prompt in the REPL looks like this:

https://multimedialib.files.wordpress.com/2019/05/emacs-geiser-guile-repl-no-prompt-found-2019-05-13.png

After trying some things out with help from str1ngs on #guix, we found out that the problem is related to the ".guile" file that seems to be generated by the system by default. In my case, ".guile" looks like this:

##########
(cond ((false-if-exception (resolve-interface '(ice-9 readline)))
       =>
       (lambda (module)
         ;; Enable completion and input history at the REPL.
         ((module-ref module 'activate-readline))))
      (else
       (display "Consider installing the 'guile-readline' package for
convenient interactive line editing and input history.\n\n")))

      (unless (getenv "INSIDE_EMACS")
        (cond ((false-if-exception (resolve-interface '(ice-9 colorized)))
               =>
               (lambda (module)
                 ;; Enable completion and input history at the REPL.
                 ((module-ref module 'activate-colorized))))
              (else
               (display "Consider installing the 'guile-colorized' package
for a colorful Guile experience.\n\n"))))
##########

When I remove this file and try to connect again, the "No prompt  found!" error disappears, and the prompt looks normal.

## System information

$ guix describe
Generation 1	May 06 2019 11:29:00	(current)
  guix d6a68e9
    repository URL: https://git.savannah.gnu.org/git/guix.git
    branch: master
    commit: d6a68e90483b35bdc2ea78afe2c81873be67ec95

I'm using Emacs 26.2, Geiser 0.10, and Guile 2.2.4, all installed as Guix packages.

---
https://sirgazil.bitbucket.io/